package polyglot.ext.polyj.parse;

import polyglot.ast.*;
import polyglot.visit.*;
import polyglot.util.*;

/**
 * An <code>UnwrapVisitor</code> rewrites the AST to remove any Wrapped
 * nodes resulting from the parser.
 */

public class UnwrapVisitor extends NodeVisitor {
    boolean error = false;

    public Node override(Node n) {
        if (!error && n instanceof Wrapper) {
            try {
                return ((Wrapper) n).parse.toExpr().visit(this);
            } catch (Exception e) {
		error = true;
            }
        }

        if (error) {
            return n;
        }

        return null;
    }
}
