package polyglot.ext.polyj.types;

import java.util.*;

/**
 * Thrown by the ConstraintChecker if any constraints
 * are unsatisfied.  Contains a list of the potentially
 * multiple SemanticExceptions representing the
 * unsatisfied constraints.
 */
public class ConstraintException extends Exception
{
    protected List errors;

    public ConstraintException() {
        super();
    }

    public ConstraintException(List errors) {
        super();
        this.errors = errors;
    }

    /**
     * Returns a list of SemanticExceptions.
     */
    public List errors() {
        return errors;
    }
}
