
package polyglot.ext.polyj.util;

import java.util.*;
import polyglot.types.*;
import polyglot.ext.polyj.types.*;

public interface TranslationTable {

    //Returns the set of all instantiations
    public Set/*[ClassType]*/ instantiations();

    /**
     * Return an iterator over the new array methods (that is,
     * the number of arguments for each method) for param.
     */
    public Iterator/*[Integer]*/ newArrayMethods(ParamType param);

    /**
     * Returns a list of adapter bindings for all the classes that
     * the given polymorphic type instantiates
     */
    public Iterator/*of AdapterBinding*/ getAdapterBindings(ClassType poly);

    /**
     * Returns the adpater binding for the given assisted instantiation
     */
    public AdapterBinding getAdapterBinding(PolyJClassType assistant,
                        ClassType inst);

    /**
     * returns the type whose adapter must be created by the
     * given instantiation's adapter interface for the
     * given adapter binding.
     */
    public ClassType getInstantiatedClass(ClassType inst,
        AdapterBinding adapter);

}
