package polyglot.ext.pure.extension;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;

import polyglot.ext.jl.ast.*;

import polyglot.ext.pure.types.*;
import polyglot.ext.pure.ast.*;

import java.util.*;

/** The Pure extension of the <code>Assign</code> node. 
 * 
 *  @see polyglot.ext.jl.ast.Assign_c
 */
public class PureAssignExt extends JL_c
{
    public PureAssignExt() { }

    public Node typeCheck(TypeChecker tc) throws SemanticException {
        Assign n = (Assign) super.typeCheck(tc);

        PureTypeSystem ts = (PureTypeSystem) tc.typeSystem();
        CodeInstance ci = tc.context().currentCode();

        if (ci.flags().contains(ts.Pure())) {
            // Permit assignments to this.f in a constructor.
            if (n.left() instanceof Field &&
                ! (ci instanceof ConstructorInstance &&
                   ((Field) n.left()).target() instanceof Special)) {
                throw new SemanticException("Cannot assign to field in " +
                                            ci + ".");
            }
            else if (n.left() instanceof ArrayAccess) {
                throw new SemanticException("Cannot assign to array in " +
                                            ci + ".");
            }
        }

        return n;
    }
}
